/****************************************************************************/
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/cursorfont.h>
#include	<X11/keysym.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<unistd.h>
#include	<sys/fcntl.h>
#include	<errno.h>
#include	<math.h>

#include	<sys/time.h>

#include	<sys/mman.h>
#include	<sys/types.h>
#include	<sys/ioctl.h>

#include	<sys/ipc.h>
#include	<sys/shm.h>
#include	<X11/extensions/XShm.h>

#define		TRUE	1
#define		FALSE	0

/*****************************************************************************/

#include	"M6809.h"
#include        "keys.h"

/*****************************************************************************/

#ifdef SCALE2
#define WIDTH 640
#define HEIGHT 400
#else
#define WIDTH 320
#define HEIGHT 200
#endif

int			width		=WIDTH;
int			height		=HEIGHT;
//int			bMITShm		=1;

Window			win,root;

int			hScreen;
unsigned long		Black,White;

XEvent			ev;
Display *		dpy;
Visual *		visual;
int			depth;
int			colorbytes;
Status			status;
XImage *		pXImage		=NULL;
char *			XImageData	=NULL;
XShmSegmentInfo 	shmInfo;
GC			gc;
XGCValues		gcv;
unsigned long		gcmask;


/*************************************************************************************************/
/*************************************************************************************************/
void		OpenWindow(void)
{
	hScreen		=DefaultScreen(dpy);
	visual		=DefaultVisual(dpy,0);
	depth		=DefaultDepth(dpy,0);
	colorbytes	=(depth+7)>>3;
	root		=DefaultRootWindow(dpy);
	Black		=BlackPixel(dpy,hScreen);
	White		=WhitePixel(dpy,hScreen);

	win=XCreateSimpleWindow(dpy,root,0,0,width,height,0,Black,White);
	XSelectInput(dpy,win,		KeyPressMask|
					KeyReleaseMask|
					PointerMotionMask|
					ButtonPressMask|
					ButtonReleaseMask);

	XMapWindow(dpy,win);
	gcv.foreground	=Black^White;
	gcv.background	=White;
	gcv.line_width	=2;
	gcv.function	=GXcopy;
	gcmask		=GCForeground|GCBackground|GCLineWidth|GCFunction;
	gc=XCreateGC(dpy,win,gcmask,&gcv);
//	if (bMITShm)
		{
		XStoreName(dpy,win,"MO5 X11_MITSHM Emulator");

		pXImage=XShmCreateImage(dpy,visual,DefaultDepth(dpy,DefaultScreen(dpy)),
					ZPixmap,NULL,&shmInfo,width,height);
		shmInfo.shmid=shmget(IPC_PRIVATE,pXImage->bytes_per_line*height,IPC_CREAT|0777);
		if (shmInfo.shmid<0)
			{ fprintf(stderr,"Error with MIT-SHM shmget\n");
			exit(1); }
		XImageData=shmInfo.shmaddr=pXImage->data=shmat(shmInfo.shmid,0,0);
		if ((char*)pXImage->data==(char*)-1) { fprintf(stderr,"error: shmat\n"); exit(1); }
		shmInfo.readOnly=False;
		if (!XShmAttach(dpy,&shmInfo)) { fprintf(stderr,"error: XShmAttach\n"); exit(1); }
		}
//	else	{
//		XStoreName(dpy,win,"XImage");
//
//		pXImage=XCreateImage(dpy,visual,depth,ZPixmap,0,NULL,width,height,32,0);
//		XImageData=pXImage->data=(char*)malloc(pXImage->bytes_per_line*height);
//		}
	if (colorbytes==3)
		{ colorbytes=pXImage->bytes_per_line/width;	// the only way i found to get the REAL
		depth=colorbytes*8; }				// depth of screen in 24/32bpp :\

	fprintf(stderr,"X11.OpenWindow: Depth=%d bits\n",depth);
	fprintf(stderr,"X11.OpenWindow: MIT-SHM window opened\n");

}

/*************************************************************************************************/
/*************************************************************************************************/
void		CloseWindow(void)
{
	if (pXImage!=NULL);
		{
		pXImage->data=XImageData;
//		if (bMITShm)
			{ XShmDetach(dpy,&shmInfo); XDestroyImage(pXImage);
			shmdt(shmInfo.shmaddr); shmctl(shmInfo.shmid,IPC_RMID,0); }
//		else	XDestroyImage(pXImage);
		}

	XCloseDisplay(dpy);
}

/************************************************************************/

extern unsigned char key[64];
extern unsigned short keytbl[];
extern unsigned int colort[16];

char *colorname[16]={
	"black",
	"red",
	"green",
	"yellow",
	"blue",
	"magenta",
	"cyan",
	"white",
	"gray",
	"mistyrose",
	"aquamarine2",
	"lightyellow",
	"steelblue1",
	"pink",
	"gray90",
	"orange"
};

void initcolor()
{
	int i;
	Colormap cmap;
	XColor p1,p2;

	cmap=DefaultColormap(dpy,hScreen);
	for (i=0;i<16;i++) {
		XAllocNamedColor(dpy,cmap,colorname[i],&p1,&p2);
		colort[i]=p1.pixel;
	}
	fprintf(stderr,"X11.initcolor: 16 color cells allocated\n");
}


/************************************************************************/

extern int dirtyvideo;
extern int keycommand;

#ifdef	SOUND
extern void sound_flush();
#endif

unsigned int pen_x,pen_y,pen_b=0;
unsigned int joystick=0xffff;

void video_update()
{
	static int ff=0;
	int i,x,y;

	if (ff){

		if (dirtyvideo)
			XShmPutImage(dpy,win,gc,pXImage,0,0,0,0,width,height,0);
		dirtyvideo=0;
		while (XPending(dpy)) {
			XNextEvent(dpy,&ev);
			switch (ev.type) {
                        case MotionNotify:
                                pen_x=ev.xbutton.x;
                                pen_y=ev.xbutton.y;
#ifdef SCALE2
                                pen_x>>=1;
                                pen_y>>=1;
#endif
                                break;
                        case ButtonPress:
                                pen_b=1;
                                //switch(((XButtonEvent*)&ev)->button){
			        break;
                        case ButtonRelease:
                                pen_b=0;
                                break;
			case KeyPress:	  i=ev.xkey.keycode;
#ifdef DEBUG1
	fprintf(stderr,"KeyPress.keycode = 0x%X\n",i);
#endif
                                if (i>=0x75) break;
                                i=keytbl[i];
                                switch(i&0x0f00) {
                                case JOYUP:    joystick&=~0x0001; break;
                                case JOYDOWN:  joystick&=~0x0002; break;
                                case JOYLEFT:  joystick&=~0x0004; break;
                                case JOYRIGHT: joystick&=~0x0008; break;
                                case JOYBUTT:  joystick&=~0x4000; break;
                                }
			        i&=0xff;
			        if (i>=0x40) keycommand=i;
				else { key[i]=1; keycommand=0x40; }
				break;
			case KeyRelease:  i=ev.xkey.keycode;
                                if (i>=0x75) break;
                                i=keytbl[i];
                                switch(i&0x0f00) {
                                case JOYUP:    joystick|=0x0001; break;
                                case JOYDOWN:  joystick|=0x0002; break;
                                case JOYLEFT:  joystick|=0x0004; break;
                                case JOYRIGHT: joystick|=0x0008; break;
                                case JOYBUTT:  joystick|=0x4000; break;
                                }
				i&=0xff;
				if (i>0x71) break;
				if (i<0x40) key[i]=0;
				break;
			}
		}

	}
	ff^=1;
}



/*************************************************************************************************/
void		initvideo()
{
	dpy=XOpenDisplay(0);
	if (dpy==NULL) { printf("can' open display."); exit(1); }

	atexit(CloseWindow);

	OpenWindow();
	initcolor();

	XFlush(dpy);

}
