#include <stdio.h>
#include "keys.h"

// default keymap for LINUX on Spanish Keyboards

unsigned short keytbl[256]={
	NOP,	//0
	NOP,	//1
	NOP,	//2
	NOP,	//3
	NOP,	//4
	NOP,	//5
	NOP,	//6
	NOP,	//7
	NOP,	//8
	0x37,	//9	STOP	(esc)
	0x2f,	//a	1
	0x27,	//b	2
	0x1f,	//c	3
	0x17,	//d	4
	0x0f,	//e	5
	0x07,	//f	6
	0x06,	//10	7
	0x0e,	//11	8
	0x16,	//12	9
	0x1e,	//13	0
	NOP,	//14
	NOP,	//15
	0x29,	//16	LEFT	(backspace)
	NOP,	//17
	0x2d,	//18	Q
	0x25,	//19	W
	0x1d,	//1a	E
	0x15,	//1b	R
	0x0d,	//1c	T
	0x05,	//1d	Y
	0x04,	//1e	U
	0x0c,	//1f	I
	0x14,	//20	O
	0x1c,	//21	P
	NOP,	//22
	0x2e,	//23	+
	0x34,	//24	ENTER
	0x35,	//25	CNTRL
	0x2b,	//26	A
	0x23,	//27	S
	0x1b,	//28	D
	0x13,	//29	F
	0x0b,	//2a	G
	0x03,	//2b	H
	0x02,	//2c	J
	0x0a,	//2d	K
	0x12,	//2e	L
	NOP,	//2f
	0x36,	//30	ACC	(' accute)
	0x1a,	//31	@	(/)
	0x38,	//32	SHIFT
	NOP,	//33
	0x30,	//34	Z
	0x28,	//35	X
	0x32,	//36	C
	0x2a,	//37	V
	0x22,	//38	B
	0x00,	//39	N
	0x08,	//3a	M
	0x10,	//3b	,
	0x18,	//3c	.
	0x26,	//3d	-
	0x38,	//3e	SHIFT
	0x2c,	//3f	*	(* keypad)

	0x33,	//40	CLS	(Alt)
	0x20,	//41	SPACE
	NOP,	//42
	HELP,	//43		(F1)
	SAVESTATUS,	//44	(F2)
	LOADSTATUS,	//45	(F3)
	ATTACHTAPE,	//46	(F4)
	REWINDTAPE,	//47	(F5)
	LOADHEX,	//48	(F6)
	ATTACHTOUT,	//49    (F7)
	TURBO,	//4a		(F8)
	NOP,	//4b
	EXITEMU,	//4c	(F10)
	NOP,	//4d
	NOP,	//4e
	NOP,	//4f

	NOP,	//50
	NOP,	//51
	NOP,	//52
	NOP,	//53
	NOP,	//54
	NOP,	//55
	NOP,	//56
	NOP,	//57
	NOP,	//58
	NOP,	//59
	NOP,	//5a
	NOP,	//5b
	NOP,	//5c
	NOP,	//5d
	JOYBUTT,	//5e
	NOP,	//5f

	RESET,	//60		(F12)
	0x11,	//61	HOME	(home)
	0x31|JOYUP,	//62	UP	(up cursor)
	NOP,	//63
	0x29|JOYLEFT ,	//64	LEFT	(left cursor)
	NOP,	//65
	0x19|JOYRIGHT ,	//66	RIGHT	(right cursor)
	NOP,	//67
	0x21|JOYDOWN,	//68	DOWN	(down cursor)
	NOP,	//69
	0x09,	//6a	INS	(insert)
	0x01,	//6b	DEL	(delete)
	NOP,	//6c
	0x35,	//6d	CNTRL	(control)
	RESET,	//6e		(pause/break)
	NOP,	//6f

	0x24,	//70	/	(/ keypad)
	0x39,	//71	BASIC	(Alt Gr)
        NOP,    //72
        NOP,    //73    Windows Key
        NOP,    //74
        NOP,    //75    Menu Key
};

void init_keytbl(char *fn)
{
    unsigned int i,k;
    FILE *fp;

    if ((fp=fopen(fn,"r"))==NULL) {
        fprintf(stderr,"init_keytbl: cannot open %s. Using default keymap\n",fn);
        return;
    }
    for (i=0;i<256;i++) {
        fscanf(fp,"%04x",&k);
        if (feof(fp)) break;
        keytbl[i]=k;
        //printf("%02x %04X\n",i,k);
    }
    fclose(fp);
    fprintf(stderr,"init_keytbl: \"%s\" keytable loaded: %d entries\n",fn,i);
}
