#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

extern unsigned long m6809_cpu_clk;
enum {WMARK=0,WTYPE,WLEN,TDATA};

int tout_fd=-1,tostatus=WMARK;


// Details:
//  The last byte of the blocks seems to be corrupted
//  This can be due to the lack of padding bits after last byte.
//  The last byte of each block is a checksum. We can just ignore
//  the transmitted checksum and compute it from data.

void bitout(int bit)
{
    static int bitix=0,m=0,ty,nbytes;
    static unsigned char data,ck;

    if (tostatus==WMARK) {
        m<<=1; m|=bit; m&=0xffffff;
        if (m==0x013c5a) { tostatus++; bitix=0; }
        return;
    }
    data<<=1; data|=bit;
    bitix=(bitix+1)&7;
    if (!bitix) {
        switch(tostatus) {
        case WTYPE: ty=data;
                    if (tout_fd>0) write(tout_fd,&data,1);
                    tostatus++;
                    break;
        case WLEN:  nbytes=data;
                    if(!nbytes) nbytes=0x100;
#ifdef DEBUG
                    if (ty==0) fprintf(stderr,"\nTape_OUT Block (type.len) = ");
                    fprintf(stderr," %02X.%03X ",ty,nbytes);
                    if (ty==0xff) fprintf(stderr,"\n");
                    fflush(stderr);
#endif
                    if (tout_fd>0) write(tout_fd,&data,1);
                    nbytes--;
                    tostatus++;
                    ck=0;
                    break;
        case TDATA: if (tout_fd>0) write(tout_fd,&data,1);
                    ck+=data;
                    nbytes--;
                    if (!nbytes) { // End of packet: check checksum
                        if (ck) {
                           fprintf(stderr,"(Checksum Error:0x%02X) ",ck);
                           fflush(stdout);
                        }
                        tostatus=WMARK; m=0;
                    }
                    break;
        }
    }
}

extern int tout_edges;

void tapeout(unsigned char data)
{
    static unsigned char ldata;
    static unsigned char bit;
    static unsigned long clktime;
    int pw;

    if (data^ldata) {                   // Register changes of cassette output
        ldata=data;
        tout_edges++;                   // This counter is to signal output
                                        // activity and to disable tape_input
        pw=m6809_cpu_clk-clktime;
        if (pw>566) {                   // Clock (long) transition
            clktime=m6809_cpu_clk;
            bitout(bit);
            bit=0;
        } else bit=1;                   // short transition => ONE
    }
}

void flushtout()
{
    int i;
    if (tout_fd>0) close(tout_fd);
}

void opentout(char *fn)
{
    if (tout_fd>0) close(tout_fd);
    tout_fd=-1;
    if ((tout_fd=creat(fn,0666))==-1) {perror("creating tape_out"); return;}
    fprintf(stderr,"Tape_OUT File created : %s\n",fn);
}

void tout_attach()
{
    char fn[256];

	printf("Tapeout: File to dump output :"); fflush(stdout);
	gets(fn);
	opentout(fn);
}
